<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="fr.ge.feedback.service.mapper.IFeedbackMapper">

	<resultMap id="feedbackBeanMap" type="fr.ge.feedback.service.bean.FeedbackBean">
		<result property="id" column="ID" />
		<result property="comment" column="COMMENT" />
		<result property="page" column="PAGE" />
		<result property="rate" column="RATE" />
		<result property="created" column="CREATED" />
		<result property="updated" column="UPDATED" />
	</resultMap>


	<insert id="create" parameterType="fr.ge.feedback.service.bean.FeedbackBean">
		<selectKey keyProperty="feedback.id" statementType="PREPARED"
			resultType="long" order="BEFORE">select nextval('sq_feedback')</selectKey>
		INSERT INTO feedback (
		id,
		comment,
		page,
		rate,
		created,
		updated
		) VALUES (
		#{feedback.id},
		#{feedback.comment},
		#{feedback.page},
		#{feedback.rate},
		#{feedback.created},
		#{feedback.updated}
		)
	</insert>

	<update id="update">
		UPDATE feedback SET
		comment = #{feedback.comment},
		rate = #{feedback.rate},
		updated = #{feedback.updated}
		WHERE id =
		#{feedback.id}
	</update>


	<delete id="deleteById">
		delete from feedback where id = #{id}
	</delete>

	<delete id="deleteByPage">
		delete from feedback where page = #{page}
	</delete>


	<sql id="fragmentSearch">
		SELECT *
		FROM feedback
	</sql>

	<select id="findAll" statementType="PREPARED" resultMap="feedbackBeanMap">
		<include refid="fragmentSearch" />
		<trim prefix="WHERE ">
            <foreach collection="filters.values()" item="filter" open=""
                separator=" AND " close="">
                <if test='filter.column == "rate"'>
                    <if test='filter.operator == ":"'>
                        rate = #{filter.value}
                    </if>
                    <if test='filter.operator == "&#62;"'>
                        rate > #{filter.value}
                    </if>
                    <if test='filter.operator == "&#60;"'>
                        rate &#60; #{filter.value}
                    </if>
                </if>
                <if test='filter.column == "comment"'>
                    <if test='filter.operator == "%"'>
                        comment like '${filter.value}%'
                    </if>
                </if>
            </foreach>
        </trim>
        <trim prefix="ORDER BY ">
            <foreach collection="orders" item="order" open="" separator=", "
                close="">
                <if test="order.column in { 'created', 'updated','rate','comment','page' }">
                    ${order.column} ${order.order}
                </if>
            </foreach>
        </trim>
	</select>

	<select id="count" statementType="PREPARED" resultType="long">
		SELECT COUNT(1)
		FROM (
		<include refid="fragmentSearch" />
		) m
	</select>

	<select id="findByPage" statementType="PREPARED" resultMap="feedbackBeanMap">
		SELECT *
		FROM feedback
		WHERE page = #{page}
		ORDER BY updated ASC
	</select>

	<select id="findById" statementType="PREPARED" resultMap="feedbackBeanMap">
		SELECT
		*
		FROM feedback
		WHERE id = #{id}
	</select>
</mapper>